
#include <stdio.h>
#include <badpenguin-chain.h>
#include "badpenguin-hardware.h"

int main() {
  TChain *tux;
  TChainItem *c;
  TPciDevice *dev;

  printf("===== scanmodule.c =====\n");
  tux = NULL;
  tux = query_pci_devices(NULL,0);
  parse_pci_devices(tux);
  check_pci_devices(tux);
  c = tux->head;
  while (c!=NULL) {
    dev = TPCIDEVICE(c->data);
    if (dev->status >= MODULE_STATUS_GENERIC ) {
      printf( 
        "Found %-7s %-7s: %s %s (%4x:%4x)\n", 
        dev->className, dev->kernelModule,
        dev->vendorName, dev->deviceName,
        dev->vendor, dev->device
      );
      if (dev->status == MODULE_STATUS_RUNNING ) {
        printf( "      Running.\n" );
      } else {
        printf( "      Loading...\n" );
	//TODO: add load code but only for SCSI devices
      }
    }
    c = c -> next;
  }

  return 0;
}
